<?php
/*
Fast Edit BE (Snippet Manager) - A tool to edit multiple web page snippets (C) 2010-2011 Beverley Hooton
(author website - http://fast-edit.co.uk/)

    Fast Edit is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/ 
session_start();
if(isset($use_ob_gzhandler) && ($use_ob_gzhandler == '1')) {
	ob_start('ob_gzhandler'); // use gzip to compress web page - requires zlib extension http://php.net/ob-gzhandler
	} else {
    	ob_start(); // cant use ob_gzhandler and zlib.output_compression together
	}
require('fast_edit_login.php');
include('fast_edit_config.php');
include('fast_edit_functions.php');
include('tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/config_tinybrowser.php');

if($_SESSION['username']) {
	$_SESSION['editfile'] = isset($_GET['editfile']) ? $_GET['editfile'] : '';

	if ( (isset($_GET['action'])) && ($_GET['action']=='save') ) // save changes to fast-edit textarea
		{
		$editfile = $_POST['editfile'];
		if ( $editfile == '' ) {
 			header("Location: index.php" );
			exit();
			}
		$contentpage_edit = $root.$editfile;
		$rpath = normalizePath(realpath($contentpage_edit));
		$root = normalizePath($root);
		if(strpos($rpath, $root) === 0) { // Check that $rpath is within allowed directory
			$allowed = true;
			}
		if ( file_exists($contentpage_edit) && strpos($contentpage_edit, '.txt',1) && $allowed ) {
			$data = $_POST['fastedit'];
			$fp = fopen($contentpage_edit,'w');
			$data = stripslashes($data);
// Comment-out the line below to allow PHP to be used via the editor window
			$data = preg_replace(array('/<(\?|\%)\=?(php)?/', '/(\%|\?)>/'), array('',''), $data); // remove old-asp tags, php short-tags, php echo tags, and normal php tags
// Comment-out the line above to allow PHP to be used via the editor window
			fwrite($fp,$data);
			fclose($fp);
			}
		header("Location: index.php?action_edit=edit&editfile=".$editfile );
		exit();
		}

	$action = (isset($_GET['action'])) ? $_GET['action'] : '';
	switch($action) 
		{
			case 'backup':
		$backupfile = $_GET['backupfile'];
		copy($root.$backupfile, $rootbackup.$backupfile);
		@copy($root_side.$backupfile, $rootbackup_side.$backupfile);
		header('Location: index.php');
		exit();
		break;
			case 'restore':
		$restorefile = $_GET['restorefile']; 
		copy($rootbackup.$restorefile, $root.$restorefile);
		@copy($rootbackup_side.$restorefile, $root_side.$restorefile);
		header('Location: index.php');
		exit();
		break;
			default:
		break;
		}

	}
?>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8" />
<title>Administration : <?php echo $website_title ;?></title>
<link rel="stylesheet" href="styles/fast_edit.css" />
</head> 
<?php flush(); ?>
<body>
<h2 style="text-align:center">Administration : <a href="<?php echo $siteurl?>" target="_blank" title="View <?php echo $website_title?>"><?php echo $website_title?> <span class="web"></span></a></h2>
<div class="fast-edit-outer"><div class="fast-edit-container">

<?php if($_SESSION['username']) { ?>
<span id="welcome">Welcome back <?php echo $_SESSION['username'];?></span>
<span id="logout">Logout <?php echo $_SESSION['username'];?>: <a href="?action=logout"><span title="Logout <?php echo $_SESSION['username'];?>" class="logout"></span></a></span>
<br/>

<div class="editor">

	<?php 
	$action_edit = (isset($_GET['action_edit'])) ? $_GET['action_edit'] : '';
	$editfile = $_GET['editfile'];
	$editf = substr($editfile, 0, strpos($editfile, '.'));
	$editf = str_replace(array('-','_'), ' ', $editf);
	$data = file_get_contents($root.$editfile); // populate fast-edit textarea with content.txt page
	$last_modified = filemtime($root.$editfile);

	if (isset($_GET['action_edit'])) {
		echo "<div id='edit-info' class='last-updated'>You are editing the \"<b>$editf</b>\" snippet : Last updated at ".gmdate("h:ia, F jS\, Y", ($last_modified+($gmt_offset*3600)))."</div>";
		} else {
		echo "<div id='edit-info' class='last-updated'>There is no snippet currently selected</div>";
		} 
	?>
<br style="clear:both"/><br/>

<table>
    <tr>
	<td class="snip-left">

		<div class="page-manager-container">
			<span class="heading">Snippet Manager</span>
			<br style="clear:both"/><br/>

			<?php if($_SESSION['username']) {
				$dir = opendir($root); 
				while (false !== ($page = readdir($dir))) {
					if (strpos($page, '.txt',1)) { 
						if ( ($page!='..') && ($page!='.') ) {
							$title = substr($page,0,strrpos($page,'.'));
							$title1 = str_replace(array('-','_'), ' ', $title);
							$contentpage_backup = $rootbackup.$title.'.txt';
							$backup_time = gmdate("h:ia", (@filemtime($contentpage_backup)+($gmt_offset*3600)));
							$backup_date = gmdate("d-M-y", (@filemtime($contentpage_backup)+($gmt_offset*3600)));
							$contentpage_current = $root.$title.'.txt';

							$current_time = gmdate("h:ia", (filemtime($contentpage_current)+($gmt_offset*3600)));
							$current_date = gmdate("d-M-y", (filemtime($contentpage_current)+($gmt_offset*3600))); 

							if ( file_exists($contentpage_backup) ) {
								if ( filemtime($contentpage_backup) < filemtime($contentpage_current) ) {  
									$bclass = "backup-old";
									} else {  
									$bclass = "yes-backup";
									}
								$backup_page = "<a href='javascript:confirmBackup(\"".$_SERVER['PHP_SELF']."?action=backup&backupfile=$page\")' title='Backup File'><span class='backup'>Backup File</span></a>";
								$backup_time_status = '<span class="mini">'.filemtime($contentpage_backup).'</span><span class="'.$bclass.'">'.$backup_date.'<br/>'.$backup_time.'</span>';
								$restore_page = "<a href='javascript:confirmRestore(\"".$_SERVER['PHP_SELF']."?action=restore&restorefile=$page\")' title='Restore Backup'><span class='restore'>Restore Backup</span></a>";
								} else {
								$backup_page = "<a href='".$_SERVER['PHP_SELF']."?action=backup&backupfile=$page' title='Backup File'><span class='backup'>Backup File</span></a>";
								$backup_time_status = '<span class="no-backup">no backup</span>';
								$restore_page = "<span title='No Restore (backup required first)' class='restore-bw'>No Restore</span>";
								}

							$list .= "<tr>\n<td class='left'>$title1</td>\n<td><a href='".$_SERVER['PHP_SELF']."?action_edit=edit&editfile=$page' title='Edit File'><span class='edit-pm'>Edit File</span></a></td>\n<td><span class='mini'>".filemtime($contentpage_current)."</span><span class='cdate'>$current_date<br/>$current_time</span></td>\n<td>$backup_page</td>\n<td>$backup_time_status</td>\n<td>$restore_page</td>\n</tr>\n";
							} 	
						}
					}
				echo "<div id='list' onscroll='SetDivPosition()'>\n<table id='snip-list' class='tablesorter'>\n<thead>\n<tr>\n<th class='left'><a href='' title='Click to Sort'>Snippet Title</a></th>\n<th><a href='' title='Click to Sort'>Edit</a></th>\n<th><a href='' title='Click to Sort'>Last Update</a></th>\n<th><a href='' title='Click to Sort'>Backup</a></th>\n<th><a href='' title='Click to Sort'>Last Backup</a></th>\n<th><a href='' title='Click to Sort'>Restore</a></th>\n</tr>\n</thead>\n<tbody>\n";
				echo $list;
				echo "</tbody>\n</table>\n</div>";
				}
			?>
		</div>

	</td><td class="snip-right">

		<form id="formeditor1" name="formeditor1" method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=save">
		<?php echo "<input type='hidden' id='editfile' name='editfile' value='$editfile' />";?>
			<textarea name="fastedit" cols="80" rows="10">
				<?php if (!isset($_GET['action_edit'])) {
					echo "Please select a file that you would like to edit from the Snippet Manager."; 
					} else { 
					echo $data; 
					} 
				?>
			</textarea> 
		</form>

	</td>
    </tr>
</table>

</div><br style="clear:both"/>

<div class="file-manager-container">
	<span class="heading">File Manager
		<span>Browse All Userfiles: <a href="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tinybrowser_filebrowser.php?type=image&folder=&feid=img" title="Browse All Userfiles" target="_blank"><span class="browse"></span></a></span>
	</span>
	<br style="clear:both"/>

	<?php if ($tinybrowser['allowupload'] == true) { 
		if ( $quota != '0' ) {
			echo '<div class="quota">';
			$bytestotal = GetFolderSize($rooturl.'userfiles');
			$percent = number_format(($bytestotal/$quota*100), 2, '.', '');
			echo "Space Quota: <b>".ByteSize($quota)."</b> &nbsp;|&nbsp; ";
			echo "Space Used: <b>".ByteSize(GetFolderSize($rooturl.'userfiles'))."</b> (".$percent."%) &nbsp; ";
			echo "<img src='images/graph.php?per=$percent' alt='$percent graph' />";
			echo '&nbsp; | &nbsp;Refresh Values: <a href="'.$_SERVER['REQUEST_URI'].'" title="Refresh Values"><span class="refresh"></span></a>';
			if ( $bytestotal >= ($quota/100*95) && $bytestotal <= $quota ) {
				echo '<div class="file-manager-quota-info">You have used <b>'.$percent.'%</b> of your maximum space quota. You can upload <b>'.ByteSize($quota-$bytestotal).'</b> more in resources before the File Manager&#39;s upload function is disabled.</div>';
 				}
			if ( $bytestotal >= $quota ) {
				echo '<div class="file-manager-error">You have reached your maximum space quota of <b>'.ByteSize($quota).'</b>. If you need more space, please consider deleting old or unwanted resources.</div>';
				}
			echo "</div>";
	 		} 
		}
	if ($tinybrowser['allowupload'] == false) { echo "<br/>"; }
	if ( $quota == '0' ) { echo "<br/>"; } 
	?>

	<table>
	   <tr>
		<td class="right">Manage&nbsp;Images:</td>
		<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('image','img'); return false;" title="Manage Images"><span class='images'></span></a></td>
		<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['image']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['image'];?>)</span></td>
	   </tr>
	   <tr>
		<td class="right">Manage&nbsp;Documents:</td>
		<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('file','img'); return false;" title="Manage Documents"><span class='docs'></span></a></td>
		<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['file']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['file'];?>)</span></td>
	   </tr>
	   <tr>
		<td class="right">Manage&nbsp;Media:</td>
		<td style="padding:0"><a href="" onclick="javascript:tinyBrowserPopUp('media','img'); return false;" title="Manage Media"><span class='media'></span></a></td>
		<td><span class="last-updated">(Upload size limit = <?php echo ByteSize($tinybrowser['maxsize']['media']);?>. Allowed file types = <?php echo $tinybrowser['filetype']['media'];?>)</span></td>
	   </tr>
	</table>
		
	<div class="file-manager-info">
		<ul class="left-list">
		<li>While using the File Manager you can perform the following actions;</li>
			<ul>
			<?php if ($tinybrowser['allowupload'] == true) { echo '<li>Upload the file types specified above</li>'; } ;?>
			<?php if ($tinybrowser['allowdelete'] == true) { echo '<li>Delete and move your uploaded files</li>'; } ;?>
			<?php if ($tinybrowser['allowfolders'] == true) { echo '<li>Create, delete and rename folders to order your content</li>'; } ;?>
			</ul>
		</ul>
		<ul class="right-list">
		<li>While using the File Browser you can view and manage your userfiles;</li>
			<ul>
			<li>Browse file/media details, such as size, type, date and path</li>
			<li>Browse images in either a thumbnail-grid or details-list view</li>
			<li>Download individual resources or select all for bulk retrieval</li>
			</ul>
		</ul>
		<br style="clear:both" />
	</div>
</div>

</div>
	<?php } else { ?>

	<p style="text-align:center">Sorry, you do not have permission to access this area. Please login.</p>
	<?php if (isset($login_error)) { echo $login_error; } ?>
	</br>
	<div style="text-align:center; margin-bottom:25px">
		Admin Login: <span class="lock"></span>
		<div class="login-box" style="display:block; margin:5px auto auto">
			<form method="post" action="<?php echo $_SERVER['PHP_SELF'];?>?action=login">
			Username:<br/><input type="text" name="name" size="15" style="margin:2px auto"/><br/>
			Password:<br/><input type="password" name="pass" size="15" style="margin:2px auto"/><br/>
			<input type="image" src="images/login.gif" name="submit_login" alt="Login" title="Login" class="login-submit"/>
			</form>
		</div>
	</div>

	<?php } ?>

</div>
 
<div class="last-updated" style="text-align:center">
	<p>Copyright &copy; 2010-<?php echo date('Y')?> Beverley Hooton &mdash; <a href="http://fast-edit.co.uk/" target="_blank" title="Visit the Fast Edit website" class="link">Fast Edit</a></p>
</div>

<?php if($_SESSION['username']) { ?>
<script src="tinymce/tinymce/jscripts/tiny_mce/tiny_mce.js"></script>
<script src="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tb_tinymce.js.php"></script>
<script src="tinymce/tinymce/jscripts/tiny_mce/plugins/tinybrowser/tb_standalone.js.php"></script>
<script src="js/fast_edit_toolbar.js"></script>
<script src="http://code.jquery.com/jquery-latest.min.js"></script>
<script src="js/jquery.tablesorter.js"></script>
<script>
$(document).ready(function() {
	$("#snip-list").tablesorter( {sortList: [[0,0], [2,0]]} ) // sort on the first column and third column, order ascending
	});
function confirmBackup(resUrl) {
	if (confirm("Overwrite previous backup file?")) { document.location = resUrl; }
	}
function confirmRestore(resUrl) {
	if (confirm("Restore this snippet from previous backup file?")) { document.location = resUrl; }
	}
window.onload = function() {
	var strCook = document.cookie;
	if(strCook.indexOf("!~")!=0) {
		var intS = strCook.indexOf("!~");
		var intE = strCook.indexOf("~!");
		var strPos = strCook.substring(intS+2,intE);
		document.getElementById("list").scrollTop = strPos;
        	}
	};
function SetDivPosition() {
	var intY = document.getElementById("list").scrollTop;
	document.cookie = "yPos=!~" + intY + "~!";
	}
</script>
<?php } ?>

</body>
</html>